/*************************************************************************\
*                                                                         *
*    File        : rx_sfd.v                                               *
*    Description : SFD detector Module                                    *
*    Designer    : Mahmud Galela (mgalela@vlsi.itb.ac.id)                 *
*                                                                         *
*    The function of this module is to detect the SFD that indicates the  *
*    beginning of data to be transfer to FIFO.                 .          *
*                                                                         *
\*************************************************************************/

module SFD_detector (
  clk, 
  reset_n, 
  data_tap, 
  SFD_start_detect, 
  SFD_detected
  );
	
  input		clk, SFD_start_detect, reset_n;
  input [3:0]	data_tap;
  output	SFD_detected;
  
  reg		SFD_detected;
   
always @(posedge clk or negedge reset_n)
begin
  if (!reset_n) 
    SFD_detected <= 1'b0;   
  else
    if (!SFD_start_detect) 
      SFD_detected <= 1'b0;
  else
    begin
      if (data_tap==4'b1101)
        SFD_detected <= 1'b1;
      else
        SFD_detected <= 1'b0; 
    end
end

endmodule 

